<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Danh sách liên hệ</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách liên hệ</h2>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">STT</th>
                    <th scope="col">Name</th>
                    <th scope="col">Email</th>
                    <th scope="col">Message</th>
                    <th scope="col">Ngày liên hệ</th>
                    <th scope="col">Sửa</th>
                    <th scope="col">Xóa</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // xóa thành công
    const gEND_OF_TABLE_ROW = -1;
    const gCOLUMN_STT = 0;
    const gCOLUMN_NAME = 1;
    const gCOLUMN_EMAIL = 2;
    const gCOLUMN_MESSAGE = 3;
    const gCOLUMN_NGAY_LIEN_HE = 4;
    const gCOLUMN_SUA = 5;
    const gCOLUMN_XOA = 6;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm thực hiện khi load trang
    function onPageLoading() {
        getAllListContact();
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện việc load all list contact từ server và load vào table
    function getAllListContact() {
        /**
       * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
       */
        // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
        // B2: Validate dữ liệu (trong bài này bước này ko cần)
        // B3: Thực hiện việc gọi API từ server Server
        var vXmlHttpGetAllListContact = new XMLHttpRequest();
        callApiToGetAllListContact(vXmlHttpGetAllListContact);

        // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
        vXmlHttpGetAllListContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                loadListContactToTable(vXmlHttpGetAllListContact);
            }
        };
    }
    // Hàm xác nhận xóa liên hệ
    function confirmDelete(contactId) {
        if (confirm("Bạn có chắc chắn muốn xóa liên hệ này?")) {
            deleteContact(contactId);
        }
    }
    // Hàm gọi API để xóa thông tin liên hệ
    function deleteContact(contactId) {
        var vXmlHttpDeleteContact = new XMLHttpRequest();
        callApiToDeleteContact(vXmlHttpDeleteContact, contactId);

        vXmlHttpDeleteContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_DELETE_SUCCESS) {
                alert("Xóa thành công");
                // Chuyển về trang danh sách liên hệ
                // Gọi lại hàm để lấy danh sách liên hệ mới
               getAllListContact();
            }
        };
    }

    // Hàm gọi API để xóa thông tin liên hệ
    function callApiToDeleteContact(paramXmlHttpDeleteContact, contactId) {
        const vBaseUrl = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
        paramXmlHttpDeleteContact.open("DELETE", vBaseUrl + "contacts/" + contactId, true);
        paramXmlHttpDeleteContact.send();
    }
    // hàm gọi api để lấy all listcontact
    function callApiToGetAllListContact(paramXMLHttpGetAllListContact) {
        const vBaseUrl = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";;
        paramXMLHttpGetAllListContact.open("GET", vBaseUrl + "contacts", true);
        paramXMLHttpGetAllListContact.send();
    }
    // input: xml http request đã được trả lời
    // ouptut/end: dữ liệu hiển thị trên bảng
    function loadListContactToTable(paramXMLHttpGetAllListContact) {
        var vPerson = JSON.parse(paramXMLHttpGetAllListContact.responseText);
        var vTable = document.getElementById("table-order");
        var vTbody = document.getElementsByTagName("tbody")[0];
        for (let bI = 0; bI < vPerson.length; bI++) {
            var bRowBody = vTbody.insertRow(gEND_OF_TABLE_ROW);
            var bCellStt = bRowBody.insertCell(gCOLUMN_STT);
            var bCellName = bRowBody.insertCell(gCOLUMN_NAME);
            var bCellEmail = bRowBody.insertCell(gCOLUMN_EMAIL);
            var bCellMessage = bRowBody.insertCell(gCOLUMN_MESSAGE);
            var bCellNgayLienHe = bRowBody.insertCell(gCOLUMN_NGAY_LIEN_HE);
            var bCellSua = bRowBody.insertCell(gCOLUMN_SUA);
            var bCellXoa = bRowBody.insertCell(gCOLUMN_XOA);

            bCellStt.innerHTML = vPerson[bI].id;
            bCellName.innerHTML = vPerson[bI].name;
            bCellEmail.innerHTML = vPerson[bI].email;
            bCellMessage.innerHTML = vPerson[bI].message;
            bCellNgayLienHe.innerHTML = vPerson[bI].createDate;

            var editButton = document.createElement("button");
            editButton.innerHTML = "Sửa";
            editButton.className = "btn btn-primary edit-button";
            editButton.setAttribute("data-contact-id", vPerson[bI].id); // Gán Id vào thuộc tính data-contact-id

            // Sử dụng closure để giữ lại giá trị của bI cho mỗi nút "Sửa"
            (function (contactId) {
                editButton.onclick = function () {
                    console.log("Sửa - Id: " + contactId);
                    // Chuyển sang trang contactDetail kèm Id trên queryString
                    window.location.href = "contactDetail.html?id=" + contactId;
                };
            })(vPerson[bI].id);

            bCellSua.appendChild(editButton);

            // Tạo nút "Xóa" và gán sự kiện click
            var deleteButton = document.createElement("button");
            deleteButton.innerHTML = "Xóa";
            deleteButton.className = "btn btn-danger";
            deleteButton.onclick = function () {
                var contactId = vPerson[bI].id;
                confirmDelete(contactId); // Gọi hàm xác nhận xóa
            };
            bCellXoa.appendChild(deleteButton);


        }
    }

</script>